Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50158)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50159)
@@ -11108,117 +11284,172 @@
     push si                                   ; 56
     push di                                   ; 57
-    sub sp, 0021eh                            ; 81 ec 1e 02
+    sub sp, 0021ch                            ; 81 ec 1c 02
     push ax                                   ; 50
     mov dx, strict word 0000eh                ; ba 0e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 68 9d
+    call 0161ch                               ; e8 b4 9b
     mov si, 00122h                            ; be 22 01
-    mov word [bp-012h], ax                    ; 89 46 ee
-    mov word [bp-014h], strict word 00000h    ; c7 46 ec 00 00
-    jmp near 07b9fh                           ; e9 dd 02
-    mov es, [bp-012h]                         ; 8e 46 ee
+    mov word [bp-01ah], ax                    ; 89 46 e6
+    mov word [bp-010h], strict word 00000h    ; c7 46 f0 00 00
+    jmp near 07dc5h                           ; e9 4f 03
+    mov es, [bp-01ah]                         ; 8e 46 e6
     cmp byte [es:si+001e8h], 004h             ; 26 80 bc e8 01 04
-    jnc near 07c07h                           ; 0f 83 38 03
+    jnc near 07e2dh                           ; 0f 83 aa 03
     mov cx, strict word 0000ah                ; b9 0a 00
     xor bx, bx                                ; 31 db
     mov dx, ss                                ; 8c d2
-    lea ax, [bp-028h]                         ; 8d 46 d8
-    call 0924ah                               ; e8 6e 19
-    mov byte [bp-028h], 025h                  ; c6 46 d8 25
+    lea ax, [bp-026h]                         ; 8d 46 da
+    call 0946ah                               ; e8 da 19
+    mov byte [bp-026h], 025h                  ; c6 46 da 25
     push dword 000000008h                     ; 66 6a 08
-    lea dx, [bp-00228h]                       ; 8d 96 d8 fd
+    lea dx, [bp-00226h]                       ; 8d 96 da fd
     push SS                                   ; 16
     push dx                                   ; 52
     push strict byte 0000ah                   ; 6a 0a
-    movzx dx, byte [bp-014h]                  ; 0f b6 56 ec
+    movzx dx, byte [bp-010h]                  ; 0f b6 56 f0
     mov cx, ss                                ; 8c d1
-    lea bx, [bp-028h]                         ; 8d 5e d8
-    mov ax, word [bp-0022ah]                  ; 8b 86 d6 fd
-    call 07466h                               ; e8 6b fb
+    lea bx, [bp-026h]                         ; 8d 5e da
+    mov ax, word [bp-00228h]                  ; 8b 86 d8 fd
+    call 0761ah                               ; e8 6b fb
     test al, al                               ; 84 c0
-    je short 0790dh                           ; 74 0e
+    je short 07ac1h                           ; 74 0e
     push 00b9bh                               ; 68 9b 0b
     push 00bd4h                               ; 68 d4 0b
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 03 a0
+    call 01922h                               ; e8 64 9e
     add sp, strict byte 00006h                ; 83 c4 06
-    movzx dx, byte [bp-00227h]                ; 0f b6 96 d9 fd
-    movzx di, byte [bp-00228h]                ; 0f b6 be d8 fd
+    movzx ax, byte [bp-00225h]                ; 0f b6 86 db fd
+    movzx di, byte [bp-00226h]                ; 0f b6 be da fd
     sal di, 008h                              ; c1 e7 08
     xor bx, bx                                ; 31 db
-    or di, dx                                 ; 09 d7
-    movzx ax, byte [bp-00226h]                ; 0f b6 86 da fd
+    or di, ax                                 ; 09 c7
+    movzx ax, byte [bp-00224h]                ; 0f b6 86 dc fd
     xor dx, dx                                ; 31 d2
     mov cx, strict word 00008h                ; b9 08 00
     sal ax, 1                                 ; d1 e0
     rcl dx, 1                                 ; d1 d2
-    loop 07928h                               ; e2 fa
-    or ax, bx                                 ; 09 d8
+    loop 07adch                               ; e2 fa
+    or bx, ax                                 ; 09 c3
+    or dx, di                                 ; 09 fa
+    movzx ax, byte [bp-00223h]                ; 0f b6 86 dd fd
+    or bx, ax                                 ; 09 c3
+    mov word [bp-00eh], bx                    ; 89 5e f2
+    mov word [bp-018h], dx                    ; 89 56 e8
+    movzx di, byte [bp-00222h]                ; 0f b6 be de fd
+    sal di, 008h                              ; c1 e7 08
+    movzx dx, byte [bp-00221h]                ; 0f b6 96 df fd
+    xor bx, bx                                ; 31 db
     or di, dx                                 ; 09 d7
-    movzx dx, byte [bp-00225h]                ; 0f b6 96 db fd
-    or ax, dx                                 ; 09 d0
-    mov word [bp-010h], ax                    ; 89 46 f0
-    movzx dx, byte [bp-00224h]                ; 0f b6 96 dc fd
-    sal dx, 008h                              ; c1 e2 08
-    movzx ax, byte [bp-00223h]                ; 0f b6 86 dd fd
-    or dx, ax                                 ; 09 c2
-    mov word [bp-01eh], dx                    ; 89 56 e2
-    movzx ax, byte [bp-00222h]                ; 0f b6 86 de fd
+    movzx ax, byte [bp-00220h]                ; 0f b6 86 e0 fd
     xor dx, dx                                ; 31 d2
     mov cx, strict word 00008h                ; b9 08 00
     sal ax, 1                                 ; d1 e0
     rcl dx, 1                                 ; d1 d2
-    loop 07958h                               ; e2 fa
-    or bx, ax                                 ; 09 c3
-    or dx, word [bp-01eh]                     ; 0b 56 e2
-    movzx ax, byte [bp-00221h]                ; 0f b6 86 df fd
-    or bx, ax                                 ; 09 c3
-    mov word [bp-00eh], bx                    ; 89 5e f2
+    loop 07b0eh                               ; e2 fa
+    or ax, bx                                 ; 09 d8
+    or dx, di                                 ; 09 fa
+    movzx bx, byte [bp-0021fh]                ; 0f b6 9e e1 fd
+    or ax, bx                                 ; 09 d8
+    mov word [bp-016h], ax                    ; 89 46 ea
     test dx, dx                               ; 85 d2
-    jne short 07977h                          ; 75 06
-    cmp bx, 00200h                            ; 81 fb 00 02
-    je short 07997h                           ; 74 20
-    mov bx, 00da6h                            ; bb a6 0d
+    jne short 07b2bh                          ; 75 05
+    cmp ax, 00200h                            ; 3d 00 02
+    je short 07b4bh                           ; 74 20
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 4a 9f
+    call 018e1h                               ; e8 ab 9d
     push dx                                   ; 52
-    push word [bp-00eh]                       ; ff 76 f2
-    push word [bp-014h]                       ; ff 76 ec
+    push word [bp-016h]                       ; ff 76 ea
+    push word [bp-010h]                       ; ff 76 f0
     push 00bf3h                               ; 68 f3 0b
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 7c 9f
+    call 01922h                               ; e8 dd 9d
     add sp, strict byte 0000ah                ; 83 c4 0a
-    jmp near 07b96h                           ; e9 ff 01
-    cmp di, strict byte 00040h                ; 83 ff 40
-    jnbe short 0799eh                         ; 77 02
-    jne short 079a8h                          ; 75 0a
-    mov dword [bp-018h], strict dword 000ff003fh ; 66 c7 46 e8 3f 00 ff 00
-    jmp short 079c1h                          ; eb 19
-    cmp di, strict byte 00020h                ; 83 ff 20
-    jnbe short 079afh                         ; 77 02
-    jne short 079b9h                          ; 75 0a
-    mov dword [bp-018h], strict dword 000800020h ; 66 c7 46 e8 20 00 80 00
-    jmp short 079c1h                          ; eb 08
-    mov dword [bp-018h], strict dword 000400020h ; 66 c7 46 e8 20 00 40 00
-    mov bx, word [bp-016h]                    ; 8b 5e ea
-    imul bx, word [bp-018h]                   ; 0f af 5e e8
-    mov ax, word [bp-010h]                    ; 8b 46 f0
-    mov dx, di                                ; 89 fa
-    xor cx, cx                                ; 31 c9
-    call 091e0h                               ; e8 0e 18
-    mov word [bp-01ch], ax                    ; 89 46 e4
-    mov word [bp-01ah], dx                    ; 89 56 e6
-    mov es, [bp-012h]                         ; 8e 46 ee
+    jmp near 07dbch                           ; e9 71 02
+    mov es, [bp-01ah]                         ; 8e 46 e6
     mov al, byte [es:si+001e8h]               ; 26 8a 84 e8 01
     mov byte [bp-00ch], al                    ; 88 46 f4
-    mov dl, al                                ; 88 c2
+    cmp AL, strict byte 001h                  ; 3c 01
+    jc short 07b66h                           ; 72 0c
+    jbe short 07b6eh                          ; 76 12
+    cmp AL, strict byte 003h                  ; 3c 03
+    je short 07b76h                           ; 74 16
+    cmp AL, strict byte 002h                  ; 3c 02
+    je short 07b72h                           ; 74 0e
+    jmp short 07bc2h                          ; eb 5c
+    test al, al                               ; 84 c0
+    jne short 07bc2h                          ; 75 58
+    mov BL, strict byte 090h                  ; b3 90
+    jmp short 07b78h                          ; eb 0a
+    mov BL, strict byte 098h                  ; b3 98
+    jmp short 07b78h                          ; eb 06
+    mov BL, strict byte 0a0h                  ; b3 a0
+    jmp short 07b78h                          ; eb 02
+    mov BL, strict byte 0a8h                  ; b3 a8
+    mov al, bl                                ; 88 d8
+    add AL, strict byte 007h                  ; 04 07
+    movzx cx, al                              ; 0f b6 c8
+    mov ax, cx                                ; 89 c8
+    call 0165ch                               ; e8 d8 9a
+    test al, al                               ; 84 c0
+    je short 07bc2h                           ; 74 3a
+    mov al, bl                                ; 88 d8
+    db  0feh, 0c0h
+    ; inc al                                    ; fe c0
+    xor ah, ah                                ; 30 e4
+    call 0165ch                               ; e8 cb 9a
+    xor ah, ah                                ; 30 e4
+    mov dx, ax                                ; 89 c2
+    sal dx, 008h                              ; c1 e2 08
+    movzx ax, bl                              ; 0f b6 c3
+    call 0165ch                               ; e8 be 9a
+    xor ah, ah                                ; 30 e4
+    add ax, dx                                ; 01 d0
+    cwd                                       ; 99
+    mov di, ax                                ; 89 c7
+    mov word [bp-012h], dx                    ; 89 56 ee
+    mov al, bl                                ; 88 d8
+    add AL, strict byte 002h                  ; 04 02
+    xor ah, ah                                ; 30 e4
+    call 0165ch                               ; e8 ab 9a
+    xor ah, ah                                ; 30 e4
+    mov word [bp-014h], ax                    ; 89 46 ec
+    mov ax, cx                                ; 89 c8
+    call 0165ch                               ; e8 a1 9a
+    xor ah, ah                                ; 30 e4
+    mov word [bp-01ch], ax                    ; 89 46 e4
+    jmp short 07c07h                          ; eb 45
+    mov ax, word [bp-018h]                    ; 8b 46 e8
+    cmp ax, strict word 00040h                ; 3d 40 00
+    jnbe short 07bcch                         ; 77 02
+    jne short 07bd8h                          ; 75 0c
+    mov word [bp-014h], 000ffh                ; c7 46 ec ff 00
+    mov word [bp-01ch], strict word 0003fh    ; c7 46 e4 3f 00
+    jmp short 07bf0h                          ; eb 18
+    cmp ax, strict word 00020h                ; 3d 20 00
+    jnbe short 07bdfh                         ; 77 02
+    jne short 07be6h                          ; 75 07
+    mov word [bp-014h], 00080h                ; c7 46 ec 80 00
+    jmp short 07bebh                          ; eb 05
+    mov word [bp-014h], strict word 00040h    ; c7 46 ec 40 00
+    mov word [bp-01ch], strict word 00020h    ; c7 46 e4 20 00
+    mov bx, word [bp-014h]                    ; 8b 5e ec
+    imul bx, word [bp-01ch]                   ; 0f af 5e e4
+    mov ax, word [bp-00eh]                    ; 8b 46 f2
+    mov dx, word [bp-018h]                    ; 8b 56 e8
+    xor cx, cx                                ; 31 c9
+    call 09400h                               ; e8 fe 17
+    mov di, ax                                ; 89 c7
+    mov word [bp-012h], dx                    ; 89 56 ee
+    mov dl, byte [bp-00ch]                    ; 8a 56 f4
     add dl, 008h                              ; 80 c2 08
-    movzx bx, al                              ; 0f b6 d8
+    movzx bx, byte [bp-00ch]                  ; 0f b6 5e f4
     sal bx, 002h                              ; c1 e3 02
+    mov es, [bp-01ah]                         ; 8e 46 e6
     add bx, si                                ; 01 f3
-    mov ax, word [bp-0022ah]                  ; 8b 86 d6 fd
+    mov ax, word [bp-00228h]                  ; 8b 86 d8 fd
     mov word [es:bx+001d8h], ax               ; 26 89 87 d8 01
-    mov al, byte [bp-014h]                    ; 8a 46 ec
+    mov al, byte [bp-010h]                    ; 8a 46 f0
     mov byte [es:bx+001dah], al               ; 26 88 87 da 01
     movzx ax, dl                              ; 0f b6 c2
@@ -11228,60 +11459,59 @@
     db  066h, 026h, 0c7h, 047h, 01eh, 004h, 0ffh, 000h, 000h
     ; mov dword [es:bx+01eh], strict dword 00000ff04h ; 66 26 c7 47 1e 04 ff 00 00
-    mov ax, word [bp-00eh]                    ; 8b 46 f2
+    mov ax, word [bp-016h]                    ; 8b 46 ea
     mov word [es:bx+024h], ax                 ; 26 89 47 24
     mov byte [es:bx+023h], 001h               ; 26 c6 47 23 01
-    mov ax, word [bp-016h]                    ; 8b 46 ea
+    mov ax, word [bp-014h]                    ; 8b 46 ec
     mov word [es:bx+026h], ax                 ; 26 89 47 26
-    mov ax, word [bp-018h]                    ; 8b 46 e8
+    mov ax, word [bp-01ch]                    ; 8b 46 e4
     mov word [es:bx+02ah], ax                 ; 26 89 47 2a
-    cmp word [bp-01ah], strict byte 00000h    ; 83 7e e6 00
-    jne short 07a3bh                          ; 75 07
-    cmp word [bp-01ch], 00400h                ; 81 7e e4 00 04
-    jbe short 07a43h                          ; 76 08
+    cmp word [bp-012h], strict byte 00000h    ; 83 7e ee 00
+    jne short 07c63h                          ; 75 06
+    cmp di, 00400h                            ; 81 ff 00 04
+    jbe short 07c6bh                          ; 76 08
     mov word [es:bx+028h], 00400h             ; 26 c7 47 28 00 04
-    jmp short 07a4ah                          ; eb 07
-    mov ax, word [bp-01ch]                    ; 8b 46 e4
-    mov word [es:bx+028h], ax                 ; 26 89 47 28
-    mov bx, 00da6h                            ; bb a6 0d
+    jmp short 07c6fh                          ; eb 04
+    mov word [es:bx+028h], di                 ; 26 89 7f 28
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 77 9e
+    call 018e1h                               ; e8 67 9c
+    push word [bp-018h]                       ; ff 76 e8
+    push word [bp-00eh]                       ; ff 76 f2
+    push word [bp-01ch]                       ; ff 76 e4
+    push word [bp-014h]                       ; ff 76 ec
     push di                                   ; 57
     push word [bp-010h]                       ; ff 76 f0
-    push word [bp-018h]                       ; ff 76 e8
-    push word [bp-016h]                       ; ff 76 ea
-    push word [bp-01ch]                       ; ff 76 e4
-    push word [bp-014h]                       ; ff 76 ec
     movzx ax, byte [bp-00ch]                  ; 0f b6 46 f4
     push ax                                   ; 50
     push 00c21h                               ; 68 21 0c
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 9b 9e
+    call 01922h                               ; e8 8b 9c
     add sp, strict byte 00012h                ; 83 c4 12
     movzx ax, dl                              ; 0f b6 c2
     imul ax, ax, strict byte 00018h           ; 6b c0 18
-    mov es, [bp-012h]                         ; 8e 46 ee
+    mov es, [bp-01ah]                         ; 8e 46 e6
     mov bx, si                                ; 89 f3
     add bx, ax                                ; 01 c3
-    mov ax, word [bp-016h]                    ; 8b 46 ea
+    mov ax, word [bp-014h]                    ; 8b 46 ec
     mov word [es:bx+02ch], ax                 ; 26 89 47 2c
-    mov ax, word [bp-018h]                    ; 8b 46 e8
+    mov ax, word [bp-01ch]                    ; 8b 46 e4
     mov word [es:bx+030h], ax                 ; 26 89 47 30
-    cmp word [bp-01ah], strict byte 00000h    ; 83 7e e6 00
-    jne short 07a9dh                          ; 75 07
-    cmp word [bp-01ch], 00400h                ; 81 7e e4 00 04
-    jbe short 07aa5h                          ; 76 08
+    cmp word [bp-012h], strict byte 00000h    ; 83 7e ee 00
+    jne short 07cc1h                          ; 75 06
+    cmp di, 00400h                            ; 81 ff 00 04
+    jbe short 07cc9h                          ; 76 08
     mov word [es:bx+02eh], 00400h             ; 26 c7 47 2e 00 04
-    jmp short 07aach                          ; eb 07
-    mov ax, word [bp-01ch]                    ; 8b 46 e4
-    mov word [es:bx+02eh], ax                 ; 26 89 47 2e
+    jmp short 07ccdh                          ; eb 04
+    mov word [es:bx+02eh], di                 ; 26 89 7f 2e
     movzx ax, dl                              ; 0f b6 c2
     imul ax, ax, strict byte 00018h           ; 6b c0 18
-    mov es, [bp-012h]                         ; 8e 46 ee
+    mov es, [bp-01ah]                         ; 8e 46 e6
     mov bx, si                                ; 89 f3
     add bx, ax                                ; 01 c3
-    mov ax, word [bp-010h]                    ; 8b 46 f0
+    mov ax, word [bp-00eh]                    ; 8b 46 f2
     mov word [es:bx+032h], ax                 ; 26 89 47 32
-    mov word [es:bx+034h], di                 ; 26 89 7f 34
+    mov ax, word [bp-018h]                    ; 8b 46 e8
+    mov word [es:bx+034h], ax                 ; 26 89 47 34
     mov al, byte [es:si+0019eh]               ; 26 8a 84 9e 01
     mov ah, byte [bp-00ch]                    ; 8a 66 f4
@@ -11295,5 +11525,5 @@
     mov dx, strict word 00075h                ; ba 75 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 17 9b
+    call 01600h                               ; e8 f3 98
     db  0feh, 0c0h
     ; inc al                                    ; fe c0
@@ -11301,24 +11531,24 @@
     mov dx, strict word 00075h                ; ba 75 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 17 9b
+    call 0160eh                               ; e8 f3 98
     inc byte [bp-00ch]                        ; fe 46 f4
     mov al, byte [bp-00ch]                    ; 8a 46 f4
-    mov es, [bp-012h]                         ; 8e 46 ee
+    mov es, [bp-01ah]                         ; 8e 46 e6
     mov byte [es:si+001e8h], al               ; 26 88 84 e8 01
-    jmp near 07b96h                           ; e9 8e 00
-    mov bx, 00da6h                            ; bb a6 0d
+    jmp near 07dbch                           ; e9 90 00
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 b9 9d
-    push word [bp-014h]                       ; ff 76 ec
+    call 018e1h                               ; e8 aa 9b
+    push word [bp-010h]                       ; ff 76 f0
     movzx ax, byte [bp-00ch]                  ; 0f b6 46 f4
     push ax                                   ; 50
     push 00c4bh                               ; 68 4b 0c
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 ea 9d
+    call 01922h                               ; e8 db 9b
     add sp, strict byte 00008h                ; 83 c4 08
     mov dl, byte [bp-00ch]                    ; 8a 56 f4
     add dl, 008h                              ; 80 c2 08
-    test byte [bp-00227h], 080h               ; f6 86 d9 fd 80
+    test byte [bp-00225h], 080h               ; f6 86 db fd 80
     db  00fh, 095h, 0c0h
     ; setne al                                  ; 0f 95 c0
@@ -11327,14 +11557,15 @@
     movzx ax, byte [bp-00ch]                  ; 0f b6 46 f4
     sal ax, 002h                              ; c1 e0 02
-    mov es, [bp-012h]                         ; 8e 46 ee
+    mov es, [bp-01ah]                         ; 8e 46 e6
     mov bx, si                                ; 89 f3
     add bx, ax                                ; 01 c3
-    mov ax, word [bp-0022ah]                  ; 8b 86 d6 fd
+    mov ax, word [bp-00228h]                  ; 8b 86 d8 fd
     mov word [es:bx+001d8h], ax               ; 26 89 87 d8 01
-    mov al, byte [bp-014h]                    ; 8a 46 ec
+    mov al, byte [bp-010h]                    ; 8a 46 f0
     mov byte [es:bx+001dah], al               ; 26 88 87 da 01
-    movzx bx, dl                              ; 0f b6 da
-    imul bx, bx, strict byte 00018h           ; 6b db 18
-    add bx, si                                ; 01 f3
+    movzx ax, dl                              ; 0f b6 c2
+    imul ax, ax, strict byte 00018h           ; 6b c0 18
+    mov bx, si                                ; 89 f3
+    add bx, ax                                ; 01 c3
     mov word [es:bx+01eh], 00504h             ; 26 c7 47 1e 04 05
     mov byte [es:bx+020h], cl                 ; 26 88 4f 20
@@ -11352,42 +11583,42 @@
     mov al, byte [bp-00ch]                    ; 8a 46 f4
     mov byte [es:si+001e8h], al               ; 26 88 84 e8 01
-    inc word [bp-014h]                        ; ff 46 ec
-    cmp word [bp-014h], strict byte 00010h    ; 83 7e ec 10
-    jnl short 07c07h                          ; 7d 68
-    mov byte [bp-028h], 012h                  ; c6 46 d8 12
+    inc word [bp-010h]                        ; ff 46 f0
+    cmp word [bp-010h], strict byte 00010h    ; 83 7e f0 10
+    jnl short 07e2dh                          ; 7d 68
+    mov byte [bp-026h], 012h                  ; c6 46 da 12
     xor al, al                                ; 30 c0
-    mov byte [bp-027h], al                    ; 88 46 d9
-    mov byte [bp-026h], al                    ; 88 46 da
     mov byte [bp-025h], al                    ; 88 46 db
-    mov byte [bp-024h], 005h                  ; c6 46 dc 05
+    mov byte [bp-024h], al                    ; 88 46 dc
     mov byte [bp-023h], al                    ; 88 46 dd
+    mov byte [bp-022h], 005h                  ; c6 46 de 05
+    mov byte [bp-021h], al                    ; 88 46 df
     push dword 000000005h                     ; 66 6a 05
-    lea dx, [bp-00228h]                       ; 8d 96 d8 fd
+    lea dx, [bp-00226h]                       ; 8d 96 da fd
     push SS                                   ; 16
     push dx                                   ; 52
     push strict byte 00006h                   ; 6a 06
-    movzx dx, byte [bp-014h]                  ; 0f b6 56 ec
+    movzx dx, byte [bp-010h]                  ; 0f b6 56 f0
     mov cx, ss                                ; 8c d1
-    lea bx, [bp-028h]                         ; 8d 5e d8
-    mov ax, word [bp-0022ah]                  ; 8b 86 d6 fd
-    call 07466h                               ; e8 96 f8
+    lea bx, [bp-026h]                         ; 8d 5e da
+    mov ax, word [bp-00228h]                  ; 8b 86 d8 fd
+    call 0761ah                               ; e8 24 f8
     test al, al                               ; 84 c0
-    je short 07be2h                           ; 74 0e
+    je short 07e08h                           ; 74 0e
     push 00b9bh                               ; 68 9b 0b
     push 00bbbh                               ; 68 bb 0b
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 2e 9d
+    call 01922h                               ; e8 1d 9b
     add sp, strict byte 00006h                ; 83 c4 06
-    test byte [bp-00228h], 0e0h               ; f6 86 d8 fd e0
-    jne short 07bf2h                          ; 75 09
-    test byte [bp-00228h], 01fh               ; f6 86 d8 fd 1f
-    je near 078c2h                            ; 0f 84 d0 fc
-    test byte [bp-00228h], 0e0h               ; f6 86 d8 fd e0
-    jne short 07b96h                          ; 75 9d
-    mov al, byte [bp-00228h]                  ; 8a 86 d8 fd
+    test byte [bp-00226h], 0e0h               ; f6 86 da fd e0
+    jne short 07e18h                          ; 75 09
+    test byte [bp-00226h], 01fh               ; f6 86 da fd 1f
+    je near 07a76h                            ; 0f 84 5e fc
+    test byte [bp-00226h], 0e0h               ; f6 86 da fd e0
+    jne short 07dbch                          ; 75 9d
+    mov al, byte [bp-00226h]                  ; 8a 86 da fd
     and AL, strict byte 01fh                  ; 24 1f
     cmp AL, strict byte 005h                  ; 3c 05
-    je near 07b08h                            ; 0f 84 03 ff
-    jmp short 07b96h                          ; eb 8f
+    je near 07d2ch                            ; 0f 84 01 ff
+    jmp short 07dbch                          ; eb 8f
     lea sp, [bp-00ah]                         ; 8d 66 f6
     pop di                                    ; 5f
@@ -11398,10 +11629,10 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-_scsi_init:                                  ; 0xf7c11 LB 0x66
+_scsi_init:                                  ; 0xf7e37 LB 0x66
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
     mov dx, strict word 0000eh                ; ba 0e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 ff 99
+    call 0161ch                               ; e8 d9 97
     mov bx, 00122h                            ; bb 22 01
     mov es, ax                                ; 8e c0
@@ -11414,10 +11645,10 @@
     ; sub ah, ah                                ; 2a e4
     cmp AL, strict byte 055h                  ; 3c 55
-    jne short 07c41h                          ; 75 0c
+    jne short 07e67h                          ; 75 0c
     xor al, al                                ; 30 c0
     mov dx, 00433h                            ; ba 33 04
     out DX, AL                                ; ee
     mov ax, 00430h                            ; b8 30 04
-    call 0789eh                               ; e8 5d fc
+    call 07a52h                               ; e8 eb fb
     mov AL, strict byte 055h                  ; b0 55
     mov dx, 00436h                            ; ba 36 04
@@ -11427,10 +11658,10 @@
     ; sub ah, ah                                ; 2a e4
     cmp AL, strict byte 055h                  ; 3c 55
-    jne short 07c5ah                          ; 75 0c
+    jne short 07e80h                          ; 75 0c
     xor al, al                                ; 30 c0
     mov dx, 00437h                            ; ba 37 04
     out DX, AL                                ; ee
     mov ax, 00434h                            ; b8 34 04
-    call 0789eh                               ; e8 44 fc
+    call 07a52h                               ; e8 d2 fb
     mov AL, strict byte 055h                  ; b0 55
     mov dx, 0043ah                            ; ba 3a 04
@@ -11440,14 +11671,14 @@
     ; sub ah, ah                                ; 2a e4
     cmp AL, strict byte 055h                  ; 3c 55
-    jne short 07c73h                          ; 75 0c
+    jne short 07e99h                          ; 75 0c
     xor al, al                                ; 30 c0
     mov dx, 0043bh                            ; ba 3b 04
     out DX, AL                                ; ee
     mov ax, 00438h                            ; b8 38 04
-    call 0789eh                               ; e8 2b fc
+    call 07a52h                               ; e8 b9 fb
     mov sp, bp                                ; 89 ec
     pop bp                                    ; 5d
     retn                                      ; c3
-high_bits_save_:                             ; 0xf7c77 LB 0x17
+high_bits_save_:                             ; 0xf7e9d LB 0x17
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -11461,5 +11692,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-high_bits_restore_:                          ; 0xf7c8e LB 0x17
+high_bits_restore_:                          ; 0xf7eb4 LB 0x17
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -11473,5 +11704,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-ahci_ctrl_set_bits_:                         ; 0xf7ca5 LB 0x43
+ahci_ctrl_set_bits_:                         ; 0xf7ecb LB 0x43
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -11511,5 +11742,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-ahci_ctrl_clear_bits_:                       ; 0xf7ce8 LB 0x47
+ahci_ctrl_clear_bits_:                       ; 0xf7f0e LB 0x47
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -11551,5 +11782,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-ahci_ctrl_is_bit_set_:                       ; 0xf7d2f LB 0x39
+ahci_ctrl_is_bit_set_:                       ; 0xf7f55 LB 0x39
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
